#ifndef __TCL_TIMER_MANAGER_H__
#define __TCL_TIMER_MANAGER_H__

#include <util/types.h>

#include <map>
//#include <list>

extern "C" {
#include <tcl.h>
}

struct TclTimerObj {
  TclTimerObj(int msec, Tcl_TimerProc* z, ClientData data) : milliseconds(msec), proc(z), clientData(data), firedTime(0), remove(false) {};
  int milliseconds;
  long firedTime;
  bool remove;
  Tcl_TimerProc* proc;
  ClientData clientData;
};


class TclTimerManager {
public:
  TclTimerManager() {};
  ~TclTimerManager() {};

  static long Tcl_CreateTimerHandler(int milliseconds, Tcl_TimerProc* proc, ClientData clientData);
  static void Tcl_DeleteTimerHandler(long token);
  static void Tcl_StopTimerHandler();
  static void Tcl_Reset();
  
  static uint32 unixtime() { return timectr; }

  static std::map<long, TclTimerObj*> timerMap;
  static uint32 timectr;
  static bool stop;

private:
  static long idctr;
};



#endif

