#ifndef __RTPI_RECIPIENT__
#define __RTPI_RECIPIENT__

#ifdef WIN32
#  pragma warning (disable: 4786 4181)
#endif

namespace RTPI {
  class RtpiRecipient {
  public:
    // manage Subcomponents
    void ActivateSubcomponent() = 0;
    void DeactivateSubcomponent() = 0;
    void AddSubcomponent() = 0;
    void RemoveSubcomponent() = 0;
    
    // handle data
    void ReceiveEvent() = 0;
    void ReceiveCue() = 0;
    void ReceiveState() = 0;
    void ReceiveDeltaState() = 0;
    void ReceiveStateQuery() = 0;

    // manage participants
    void ChangeSourceInfo() = 0;
    void RemoveSource() = 0;

    // reliability interface
    void RtpiAduLost() = 0;
    void RtpiCouldNotRecover() = 0;

    // Error
    void ConnectionClosed() = 0;
  }
}


#endif
