/* -*- C++ -*-

   file.cc -- short description

   Author:    Christoph Kuhmuench
              Lehrstuhl fuer Praktische Informatik IV
              Universitaet Mannheim, Germany
              email: cjk@pi4.informatik.uni-mannheim.de

   $Id: StringTokenizer.h,v 1.1.1.1 2000/01/18 15:02:30 cjk Exp $
*/

#ifndef _STRINGTOKENIZER_H_
#define _STRINGTOKENIZER_H_

#include <string>

#define uint unsigned int

class StringTokenizer
{
private:
  string s;
  string delimeters;
  uint   pos;
  string token;
  string delim;


public:
  StringTokenizer(string _s, string _delimeters= " \t\n;:\"")
    : s(_s), delimeters(_delimeters), pos(0)
    {;};

  inline int hasMoreElements()
    { return (pos < s.len()); };

  inline int hasMoreTokens()
    { return pos < s.len(); };

  string& nextToken();

  string& getWhatsLeft();
  int countTokens() const;

  inline string& nextElement()
    { return nextToken();};

  inline string& nextToken(string _delimeters)
  {
    delimeters= _delimeters;
    return nextToken();
  };
};

#endif



