/* -*- C++ -*-

   file.h  -- short description

   Author:    Christoph Kuhmuench
              Lehrstuhl fuer Praktische Informatik IV
              Universitaet Mannheim, Germany
              email: cjk@pi4.informatik.uni-mannheim.de

   $Id: errorhandler.h,v 1.1.1.1 2000/01/18 15:02:31 cjk Exp $
*/

#ifndef _ERRORHANDLER_H_
#define _ERRORHANDLER_H_

#include <stdlib.h>
#include <string>


class DatagramSocket;
class InetAddress;


class ErrorHandler
// {{{ definition
{
private:
  static DatagramSocket*    ctrlSocket;     /// comunication sock

public:
  static void init(DatagramSocket* _ctrlSocket)
  { ctrlSocket= _ctrlSocket; };

  // ----- ---- --- -- -  send Error  - -- --- ---- ----- //
  inline static void send(string msg, InetAddress &ip, int port);

  // ----- ---- --- -- -  Logging  - -- --- ---- ----- //

  inline static void out(const string& s)
  { cout << s << endl; }

  inline static void exitout(const string& s)
  { cout << s << endl; exit(-1); }
};
// }}}

#endif
