/****************************************************************************
 *                                                                          *
 *  class string                                                            *
 *  ------------                                                            *
 *                                                                          *
 ****************************************************************************/
 
#ifndef _STRING_H_
#define _STRING_H_


#include <iostream.h>
extern "C" {
#include <string.h>
#include <stdlib.h> // fuer atoi, atof...
#include <stdio.h>  // fuer sprintf
#include <ctype.h>  // fuer toupper
}

#ifndef _UINT_
#define _UINT_
typedef unsigned int uint;
#endif



class string
{
//    friend int strcmp(const string& s1, const string& s2);
    friend ostream& operator<<(ostream& os, const string& s);
    friend istream& operator>>(istream& os, const string& s);
    friend string   substring(string& dest, string& src,
                              int anfang, int ende= 0);

    friend string itoa(long n);
    friend long   atoi(const string& s);

    private:
        char *s;
        mutable uint  maxlen;
        mutable uint  l;

        void init(uint siz);
        
    public:
        string(uint siz= 80);
        string(short int siz);
        string(const string& str);
        string(const char *str);
        string(const char c);
        string(const char *str, uint siz); // JCW
        
        ~string();

        void checksize() const;
        void resize(uint siz);
        void bzero();

        void upcase();
        void downcase();
        
        string& operator=(const string& str);
        string& operator=(const char *str);

        int operator==(const string& str) const;
        int operator!=(const string& str) const;
        int operator<=(const string& str) const;
        int operator>=(const string& str) const;
        int operator< (const string& str) const;
        int operator> (const string& str) const;
        int contains(const char c) const;

        int find(string sub);
        
        
        uint len()       const { return l; };
        uint length()    const { return l; };
        uint getmaxlen() const { return maxlen; };

        string  operator +(const string& str);
        string& operator -(const string& str);
        string& operator +=(const string& str);
        string& operator -=(const string& str);

        // operator [] not needed since we have cast operator (char *)
        // compiler will interpret:
        //    char c= strng[5] 
        // as
        //    char c= ((char *)strng)[5];
        //
        // const char& operator[](uint i) const;
        // char&       operator[](uint i);

        string& fromint(const long n);
        string& fromlong(const long n) { return fromint(n); };;
        string& fromul(const unsigned long n);
        string& fromdouble(const double f);
        string& fromchar(const char c);

        int    toint()    const    { char *pch; return strtol(s, &pch, 10); };
        long   tolong()   const    { char *pch; return strtol(s, &pch, 10); };
        unsigned long toul() const { return string::atoul(s); };
        double todouble() const    { return atof(s); };
        char   tochar()   const    { return s[0];    };

        static long          atoi(const char *s) { char *pch;
                                             return strtol(s, &pch, 10); };
        static unsigned long atoul(const char *s);
        
        static string&       itoa(const long  i);
        static string&      ultoa(unsigned long n);

        operator char* () const  { return s; };
        char *   c_str()  const  { return s; };
};

#endif

