// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
//
// Copyright (c) 2000 University of Mannheim. All Rights Reserved.
//
// Permission to use, copy, modify, and distribute this software and its
// documentation for educational, research and non-profit purposes,
// without fee, and without a written agreement is hereby granted,
// provided that the above copyright notice, this paragraph and the
// following four paragraphs appear in all copies.
//
// Permission to incorporate this software into commercial products may
// be obtained from the following address:
// University of Mannheim
// Lehrstuhl fuer Praktische Informatik IV
// L15, 16
// 68161 Mannheim, Germany
//
// IN NO EVENT SHALL THE UNIVERSITY OF MANNHEIM BE LIABLE TO ANY PARTY
// FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES,
// INCLUDING LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND
// ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF MANNHEIM HAS BEEN ADVISED
// OF THE POSSIBILITY OF SUCH DAMAGE.
//
// THE UNIVERSITY OF MANNHEIM SPECIFICALLY DISCLAIMS ANY WARRANTIES,
// INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
// AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER
// IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF MANNHEIM HAS NO OBLIGATIONS
// TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
//
// The University of Mannheim will appreciate receiving any enhancements and
// modifications of this software made by others, and reserves the right to
// include them in future releases. The University also recommends that this
// software not be redistributed by third parties, but be obtained by all
// directly from the University's server, so that all users of the software
// may receive bug notifications and other relevant announcements.
//
// Authors:
//   Juergen Vogel
//   University of Mannheim
//   vogel@informatik.uni-mannheim.de
//
// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
#include "win32.h"

#include <winsock.h>
#include <process.h>
#include <sys/timeb.h>
#include <sys/types.h>
#include <util/types.h>

std::ostream& operator<<(std::ostream& os, std::string s) {
  os << s.c_str();
  return os;
}


unsigned int gethostid() {
  struct hostent* host;
  struct in_addr a;
  char buf[100];
  if (gethostname(buf, sizeof(buf)) != 0) {
    return 0;
  }
  host = gethostbyname(buf);
  memcpy(&(a.s_addr), host->h_addr_list[0], host->h_length);
  return ntohl(a.s_addr);
}


uid_t getuid() {
  return 0;
}


gid_t getgid() {
  return 0;
}


double drand48() {
  static bool first = true;
  if (first) {
    struct timeval time;
    gettimeofday(&time, NULL);
    srand((int)time.tv_sec);
    first = false;
  }
  return (double(rand()) / (RAND_MAX + 1));
}

int gettimeofday(struct timeval *p, void*) {
  if (p) {
    //struct _timeb t;
    //_ftime(&t);
    struct _SYSTEMTIME t;
    GetSystemTime(&t);
    
    p->tv_sec  = time(NULL);
    p->tv_usec = t.wMilliseconds * 1000; // microsecs
  }
  return 0;
}
